package cmvr.api;

import static io.grpc.MethodDescriptor.generateFullMethodName;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.52.0)",
    comments = "Source: cmvr/api/camera_service.proto")
@io.grpc.stub.annotations.GrpcGenerated
public final class CameraServiceGrpc {

  private CameraServiceGrpc() {}

  public static final String SERVICE_NAME = "cmvr.api.CameraService";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetCameraStateCommand.Request,
      cmvr.api.CameraCommand.GetCameraStateCommand.Feedback> getGetStatusMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetStatus",
      requestType = cmvr.api.CameraCommand.GetCameraStateCommand.Request.class,
      responseType = cmvr.api.CameraCommand.GetCameraStateCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetCameraStateCommand.Request,
      cmvr.api.CameraCommand.GetCameraStateCommand.Feedback> getGetStatusMethod() {
    io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetCameraStateCommand.Request, cmvr.api.CameraCommand.GetCameraStateCommand.Feedback> getGetStatusMethod;
    if ((getGetStatusMethod = CameraServiceGrpc.getGetStatusMethod) == null) {
      synchronized (CameraServiceGrpc.class) {
        if ((getGetStatusMethod = CameraServiceGrpc.getGetStatusMethod) == null) {
          CameraServiceGrpc.getGetStatusMethod = getGetStatusMethod =
              io.grpc.MethodDescriptor.<cmvr.api.CameraCommand.GetCameraStateCommand.Request, cmvr.api.CameraCommand.GetCameraStateCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetStatus"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetCameraStateCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetCameraStateCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new CameraServiceMethodDescriptorSupplier("GetStatus"))
              .build();
        }
      }
    }
    return getGetStatusMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StartCameraCommand.Request,
      cmvr.api.CameraCommand.StartCameraCommand.Feedback> getStartCameraMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "StartCamera",
      requestType = cmvr.api.CameraCommand.StartCameraCommand.Request.class,
      responseType = cmvr.api.CameraCommand.StartCameraCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StartCameraCommand.Request,
      cmvr.api.CameraCommand.StartCameraCommand.Feedback> getStartCameraMethod() {
    io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StartCameraCommand.Request, cmvr.api.CameraCommand.StartCameraCommand.Feedback> getStartCameraMethod;
    if ((getStartCameraMethod = CameraServiceGrpc.getStartCameraMethod) == null) {
      synchronized (CameraServiceGrpc.class) {
        if ((getStartCameraMethod = CameraServiceGrpc.getStartCameraMethod) == null) {
          CameraServiceGrpc.getStartCameraMethod = getStartCameraMethod =
              io.grpc.MethodDescriptor.<cmvr.api.CameraCommand.StartCameraCommand.Request, cmvr.api.CameraCommand.StartCameraCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "StartCamera"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.StartCameraCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.StartCameraCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new CameraServiceMethodDescriptorSupplier("StartCamera"))
              .build();
        }
      }
    }
    return getStartCameraMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StopCameraCommand.Request,
      cmvr.api.CameraCommand.StopCameraCommand.Feedback> getStopCameraMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "StopCamera",
      requestType = cmvr.api.CameraCommand.StopCameraCommand.Request.class,
      responseType = cmvr.api.CameraCommand.StopCameraCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StopCameraCommand.Request,
      cmvr.api.CameraCommand.StopCameraCommand.Feedback> getStopCameraMethod() {
    io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StopCameraCommand.Request, cmvr.api.CameraCommand.StopCameraCommand.Feedback> getStopCameraMethod;
    if ((getStopCameraMethod = CameraServiceGrpc.getStopCameraMethod) == null) {
      synchronized (CameraServiceGrpc.class) {
        if ((getStopCameraMethod = CameraServiceGrpc.getStopCameraMethod) == null) {
          CameraServiceGrpc.getStopCameraMethod = getStopCameraMethod =
              io.grpc.MethodDescriptor.<cmvr.api.CameraCommand.StopCameraCommand.Request, cmvr.api.CameraCommand.StopCameraCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "StopCamera"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.StopCameraCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.StopCameraCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new CameraServiceMethodDescriptorSupplier("StopCamera"))
              .build();
        }
      }
    }
    return getStopCameraMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBImageCommand.Request,
      cmvr.api.CameraCommand.GetRGBImageCommand.Feedback> getGetRGBImageMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetRGBImage",
      requestType = cmvr.api.CameraCommand.GetRGBImageCommand.Request.class,
      responseType = cmvr.api.CameraCommand.GetRGBImageCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBImageCommand.Request,
      cmvr.api.CameraCommand.GetRGBImageCommand.Feedback> getGetRGBImageMethod() {
    io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBImageCommand.Request, cmvr.api.CameraCommand.GetRGBImageCommand.Feedback> getGetRGBImageMethod;
    if ((getGetRGBImageMethod = CameraServiceGrpc.getGetRGBImageMethod) == null) {
      synchronized (CameraServiceGrpc.class) {
        if ((getGetRGBImageMethod = CameraServiceGrpc.getGetRGBImageMethod) == null) {
          CameraServiceGrpc.getGetRGBImageMethod = getGetRGBImageMethod =
              io.grpc.MethodDescriptor.<cmvr.api.CameraCommand.GetRGBImageCommand.Request, cmvr.api.CameraCommand.GetRGBImageCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetRGBImage"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetRGBImageCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetRGBImageCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new CameraServiceMethodDescriptorSupplier("GetRGBImage"))
              .build();
        }
      }
    }
    return getGetRGBImageMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetDepthImageCommand.Request,
      cmvr.api.CameraCommand.GetDepthImageCommand.Feedback> getGetDepthImageMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetDepthImage",
      requestType = cmvr.api.CameraCommand.GetDepthImageCommand.Request.class,
      responseType = cmvr.api.CameraCommand.GetDepthImageCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetDepthImageCommand.Request,
      cmvr.api.CameraCommand.GetDepthImageCommand.Feedback> getGetDepthImageMethod() {
    io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetDepthImageCommand.Request, cmvr.api.CameraCommand.GetDepthImageCommand.Feedback> getGetDepthImageMethod;
    if ((getGetDepthImageMethod = CameraServiceGrpc.getGetDepthImageMethod) == null) {
      synchronized (CameraServiceGrpc.class) {
        if ((getGetDepthImageMethod = CameraServiceGrpc.getGetDepthImageMethod) == null) {
          CameraServiceGrpc.getGetDepthImageMethod = getGetDepthImageMethod =
              io.grpc.MethodDescriptor.<cmvr.api.CameraCommand.GetDepthImageCommand.Request, cmvr.api.CameraCommand.GetDepthImageCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetDepthImage"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetDepthImageCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetDepthImageCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new CameraServiceMethodDescriptorSupplier("GetDepthImage"))
              .build();
        }
      }
    }
    return getGetDepthImageMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBDImagesCommand.Request,
      cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback> getGetRGBDImagesMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetRGBDImages",
      requestType = cmvr.api.CameraCommand.GetRGBDImagesCommand.Request.class,
      responseType = cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBDImagesCommand.Request,
      cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback> getGetRGBDImagesMethod() {
    io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBDImagesCommand.Request, cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback> getGetRGBDImagesMethod;
    if ((getGetRGBDImagesMethod = CameraServiceGrpc.getGetRGBDImagesMethod) == null) {
      synchronized (CameraServiceGrpc.class) {
        if ((getGetRGBDImagesMethod = CameraServiceGrpc.getGetRGBDImagesMethod) == null) {
          CameraServiceGrpc.getGetRGBDImagesMethod = getGetRGBDImagesMethod =
              io.grpc.MethodDescriptor.<cmvr.api.CameraCommand.GetRGBDImagesCommand.Request, cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetRGBDImages"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetRGBDImagesCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new CameraServiceMethodDescriptorSupplier("GetRGBDImages"))
              .build();
        }
      }
    }
    return getGetRGBDImagesMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StartCameraRecordingCommand.Request,
      cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback> getStartRecordingMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "StartRecording",
      requestType = cmvr.api.CameraCommand.StartCameraRecordingCommand.Request.class,
      responseType = cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StartCameraRecordingCommand.Request,
      cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback> getStartRecordingMethod() {
    io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StartCameraRecordingCommand.Request, cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback> getStartRecordingMethod;
    if ((getStartRecordingMethod = CameraServiceGrpc.getStartRecordingMethod) == null) {
      synchronized (CameraServiceGrpc.class) {
        if ((getStartRecordingMethod = CameraServiceGrpc.getStartRecordingMethod) == null) {
          CameraServiceGrpc.getStartRecordingMethod = getStartRecordingMethod =
              io.grpc.MethodDescriptor.<cmvr.api.CameraCommand.StartCameraRecordingCommand.Request, cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "StartRecording"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.StartCameraRecordingCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new CameraServiceMethodDescriptorSupplier("StartRecording"))
              .build();
        }
      }
    }
    return getStartRecordingMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StopCameraRecordingCommand.Request,
      cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback> getStopRecordingMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "StopRecording",
      requestType = cmvr.api.CameraCommand.StopCameraRecordingCommand.Request.class,
      responseType = cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StopCameraRecordingCommand.Request,
      cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback> getStopRecordingMethod() {
    io.grpc.MethodDescriptor<cmvr.api.CameraCommand.StopCameraRecordingCommand.Request, cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback> getStopRecordingMethod;
    if ((getStopRecordingMethod = CameraServiceGrpc.getStopRecordingMethod) == null) {
      synchronized (CameraServiceGrpc.class) {
        if ((getStopRecordingMethod = CameraServiceGrpc.getStopRecordingMethod) == null) {
          CameraServiceGrpc.getStopRecordingMethod = getStopRecordingMethod =
              io.grpc.MethodDescriptor.<cmvr.api.CameraCommand.StopCameraRecordingCommand.Request, cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "StopRecording"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.StopCameraRecordingCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new CameraServiceMethodDescriptorSupplier("StopRecording"))
              .build();
        }
      }
    }
    return getStopRecordingMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBImageStreamCommand.Request,
      cmvr.api.CameraCommand.GetRGBImageStreamCommand.Feedback> getGetRGBImageStreamMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetRGBImageStream",
      requestType = cmvr.api.CameraCommand.GetRGBImageStreamCommand.Request.class,
      responseType = cmvr.api.CameraCommand.GetRGBImageStreamCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
  public static io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBImageStreamCommand.Request,
      cmvr.api.CameraCommand.GetRGBImageStreamCommand.Feedback> getGetRGBImageStreamMethod() {
    io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBImageStreamCommand.Request, cmvr.api.CameraCommand.GetRGBImageStreamCommand.Feedback> getGetRGBImageStreamMethod;
    if ((getGetRGBImageStreamMethod = CameraServiceGrpc.getGetRGBImageStreamMethod) == null) {
      synchronized (CameraServiceGrpc.class) {
        if ((getGetRGBImageStreamMethod = CameraServiceGrpc.getGetRGBImageStreamMethod) == null) {
          CameraServiceGrpc.getGetRGBImageStreamMethod = getGetRGBImageStreamMethod =
              io.grpc.MethodDescriptor.<cmvr.api.CameraCommand.GetRGBImageStreamCommand.Request, cmvr.api.CameraCommand.GetRGBImageStreamCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetRGBImageStream"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetRGBImageStreamCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetRGBImageStreamCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new CameraServiceMethodDescriptorSupplier("GetRGBImageStream"))
              .build();
        }
      }
    }
    return getGetRGBImageStreamMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetDepthImageStreamCommand.Request,
      cmvr.api.CameraCommand.GetDepthImageStreamCommand.Feedback> getGetDepthImageStreamMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetDepthImageStream",
      requestType = cmvr.api.CameraCommand.GetDepthImageStreamCommand.Request.class,
      responseType = cmvr.api.CameraCommand.GetDepthImageStreamCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
  public static io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetDepthImageStreamCommand.Request,
      cmvr.api.CameraCommand.GetDepthImageStreamCommand.Feedback> getGetDepthImageStreamMethod() {
    io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetDepthImageStreamCommand.Request, cmvr.api.CameraCommand.GetDepthImageStreamCommand.Feedback> getGetDepthImageStreamMethod;
    if ((getGetDepthImageStreamMethod = CameraServiceGrpc.getGetDepthImageStreamMethod) == null) {
      synchronized (CameraServiceGrpc.class) {
        if ((getGetDepthImageStreamMethod = CameraServiceGrpc.getGetDepthImageStreamMethod) == null) {
          CameraServiceGrpc.getGetDepthImageStreamMethod = getGetDepthImageStreamMethod =
              io.grpc.MethodDescriptor.<cmvr.api.CameraCommand.GetDepthImageStreamCommand.Request, cmvr.api.CameraCommand.GetDepthImageStreamCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetDepthImageStream"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetDepthImageStreamCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetDepthImageStreamCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new CameraServiceMethodDescriptorSupplier("GetDepthImageStream"))
              .build();
        }
      }
    }
    return getGetDepthImageStreamMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Request,
      cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Feedback> getGetRGBDImagesStreamMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetRGBDImagesStream",
      requestType = cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Request.class,
      responseType = cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
  public static io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Request,
      cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Feedback> getGetRGBDImagesStreamMethod() {
    io.grpc.MethodDescriptor<cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Request, cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Feedback> getGetRGBDImagesStreamMethod;
    if ((getGetRGBDImagesStreamMethod = CameraServiceGrpc.getGetRGBDImagesStreamMethod) == null) {
      synchronized (CameraServiceGrpc.class) {
        if ((getGetRGBDImagesStreamMethod = CameraServiceGrpc.getGetRGBDImagesStreamMethod) == null) {
          CameraServiceGrpc.getGetRGBDImagesStreamMethod = getGetRGBDImagesStreamMethod =
              io.grpc.MethodDescriptor.<cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Request, cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetRGBDImagesStream"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new CameraServiceMethodDescriptorSupplier("GetRGBDImagesStream"))
              .build();
        }
      }
    }
    return getGetRGBDImagesStreamMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static CameraServiceStub newStub(io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<CameraServiceStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<CameraServiceStub>() {
        @java.lang.Override
        public CameraServiceStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new CameraServiceStub(channel, callOptions);
        }
      };
    return CameraServiceStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static CameraServiceBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<CameraServiceBlockingStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<CameraServiceBlockingStub>() {
        @java.lang.Override
        public CameraServiceBlockingStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new CameraServiceBlockingStub(channel, callOptions);
        }
      };
    return CameraServiceBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static CameraServiceFutureStub newFutureStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<CameraServiceFutureStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<CameraServiceFutureStub>() {
        @java.lang.Override
        public CameraServiceFutureStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new CameraServiceFutureStub(channel, callOptions);
        }
      };
    return CameraServiceFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class CameraServiceImplBase implements io.grpc.BindableService {

    /**
     */
    public void getStatus(cmvr.api.CameraCommand.GetCameraStateCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetCameraStateCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getGetStatusMethod(), responseObserver);
    }

    /**
     */
    public void startCamera(cmvr.api.CameraCommand.StartCameraCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StartCameraCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getStartCameraMethod(), responseObserver);
    }

    /**
     */
    public void stopCamera(cmvr.api.CameraCommand.StopCameraCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StopCameraCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getStopCameraMethod(), responseObserver);
    }

    /**
     */
    public void getRGBImage(cmvr.api.CameraCommand.GetRGBImageCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBImageCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getGetRGBImageMethod(), responseObserver);
    }

    /**
     */
    public void getDepthImage(cmvr.api.CameraCommand.GetDepthImageCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetDepthImageCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getGetDepthImageMethod(), responseObserver);
    }

    /**
     */
    public void getRGBDImages(cmvr.api.CameraCommand.GetRGBDImagesCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getGetRGBDImagesMethod(), responseObserver);
    }

    /**
     */
    public void startRecording(cmvr.api.CameraCommand.StartCameraRecordingCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getStartRecordingMethod(), responseObserver);
    }

    /**
     */
    public void stopRecording(cmvr.api.CameraCommand.StopCameraRecordingCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getStopRecordingMethod(), responseObserver);
    }

    /**
     */
    public io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBImageStreamCommand.Request> getRGBImageStream(
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBImageStreamCommand.Feedback> responseObserver) {
      return io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall(getGetRGBImageStreamMethod(), responseObserver);
    }

    /**
     */
    public io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetDepthImageStreamCommand.Request> getDepthImageStream(
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetDepthImageStreamCommand.Feedback> responseObserver) {
      return io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall(getGetDepthImageStreamMethod(), responseObserver);
    }

    /**
     */
    public io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Request> getRGBDImagesStream(
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Feedback> responseObserver) {
      return io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall(getGetRGBDImagesStreamMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getGetStatusMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.CameraCommand.GetCameraStateCommand.Request,
                cmvr.api.CameraCommand.GetCameraStateCommand.Feedback>(
                  this, METHODID_GET_STATUS)))
          .addMethod(
            getStartCameraMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.CameraCommand.StartCameraCommand.Request,
                cmvr.api.CameraCommand.StartCameraCommand.Feedback>(
                  this, METHODID_START_CAMERA)))
          .addMethod(
            getStopCameraMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.CameraCommand.StopCameraCommand.Request,
                cmvr.api.CameraCommand.StopCameraCommand.Feedback>(
                  this, METHODID_STOP_CAMERA)))
          .addMethod(
            getGetRGBImageMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.CameraCommand.GetRGBImageCommand.Request,
                cmvr.api.CameraCommand.GetRGBImageCommand.Feedback>(
                  this, METHODID_GET_RGBIMAGE)))
          .addMethod(
            getGetDepthImageMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.CameraCommand.GetDepthImageCommand.Request,
                cmvr.api.CameraCommand.GetDepthImageCommand.Feedback>(
                  this, METHODID_GET_DEPTH_IMAGE)))
          .addMethod(
            getGetRGBDImagesMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.CameraCommand.GetRGBDImagesCommand.Request,
                cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback>(
                  this, METHODID_GET_RGBDIMAGES)))
          .addMethod(
            getStartRecordingMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.CameraCommand.StartCameraRecordingCommand.Request,
                cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback>(
                  this, METHODID_START_RECORDING)))
          .addMethod(
            getStopRecordingMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.CameraCommand.StopCameraRecordingCommand.Request,
                cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback>(
                  this, METHODID_STOP_RECORDING)))
          .addMethod(
            getGetRGBImageStreamMethod(),
            io.grpc.stub.ServerCalls.asyncBidiStreamingCall(
              new MethodHandlers<
                cmvr.api.CameraCommand.GetRGBImageStreamCommand.Request,
                cmvr.api.CameraCommand.GetRGBImageStreamCommand.Feedback>(
                  this, METHODID_GET_RGBIMAGE_STREAM)))
          .addMethod(
            getGetDepthImageStreamMethod(),
            io.grpc.stub.ServerCalls.asyncBidiStreamingCall(
              new MethodHandlers<
                cmvr.api.CameraCommand.GetDepthImageStreamCommand.Request,
                cmvr.api.CameraCommand.GetDepthImageStreamCommand.Feedback>(
                  this, METHODID_GET_DEPTH_IMAGE_STREAM)))
          .addMethod(
            getGetRGBDImagesStreamMethod(),
            io.grpc.stub.ServerCalls.asyncBidiStreamingCall(
              new MethodHandlers<
                cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Request,
                cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Feedback>(
                  this, METHODID_GET_RGBDIMAGES_STREAM)))
          .build();
    }
  }

  /**
   */
  public static final class CameraServiceStub extends io.grpc.stub.AbstractAsyncStub<CameraServiceStub> {
    private CameraServiceStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected CameraServiceStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new CameraServiceStub(channel, callOptions);
    }

    /**
     */
    public void getStatus(cmvr.api.CameraCommand.GetCameraStateCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetCameraStateCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getGetStatusMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void startCamera(cmvr.api.CameraCommand.StartCameraCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StartCameraCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getStartCameraMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void stopCamera(cmvr.api.CameraCommand.StopCameraCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StopCameraCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getStopCameraMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getRGBImage(cmvr.api.CameraCommand.GetRGBImageCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBImageCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getGetRGBImageMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getDepthImage(cmvr.api.CameraCommand.GetDepthImageCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetDepthImageCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getGetDepthImageMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getRGBDImages(cmvr.api.CameraCommand.GetRGBDImagesCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getGetRGBDImagesMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void startRecording(cmvr.api.CameraCommand.StartCameraRecordingCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getStartRecordingMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void stopRecording(cmvr.api.CameraCommand.StopCameraRecordingCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getStopRecordingMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBImageStreamCommand.Request> getRGBImageStream(
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBImageStreamCommand.Feedback> responseObserver) {
      return io.grpc.stub.ClientCalls.asyncBidiStreamingCall(
          getChannel().newCall(getGetRGBImageStreamMethod(), getCallOptions()), responseObserver);
    }

    /**
     */
    public io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetDepthImageStreamCommand.Request> getDepthImageStream(
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetDepthImageStreamCommand.Feedback> responseObserver) {
      return io.grpc.stub.ClientCalls.asyncBidiStreamingCall(
          getChannel().newCall(getGetDepthImageStreamMethod(), getCallOptions()), responseObserver);
    }

    /**
     */
    public io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Request> getRGBDImagesStream(
        io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Feedback> responseObserver) {
      return io.grpc.stub.ClientCalls.asyncBidiStreamingCall(
          getChannel().newCall(getGetRGBDImagesStreamMethod(), getCallOptions()), responseObserver);
    }
  }

  /**
   */
  public static final class CameraServiceBlockingStub extends io.grpc.stub.AbstractBlockingStub<CameraServiceBlockingStub> {
    private CameraServiceBlockingStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected CameraServiceBlockingStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new CameraServiceBlockingStub(channel, callOptions);
    }

    /**
     */
    public cmvr.api.CameraCommand.GetCameraStateCommand.Feedback getStatus(cmvr.api.CameraCommand.GetCameraStateCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getGetStatusMethod(), getCallOptions(), request);
    }

    /**
     */
    public cmvr.api.CameraCommand.StartCameraCommand.Feedback startCamera(cmvr.api.CameraCommand.StartCameraCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getStartCameraMethod(), getCallOptions(), request);
    }

    /**
     */
    public cmvr.api.CameraCommand.StopCameraCommand.Feedback stopCamera(cmvr.api.CameraCommand.StopCameraCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getStopCameraMethod(), getCallOptions(), request);
    }

    /**
     */
    public cmvr.api.CameraCommand.GetRGBImageCommand.Feedback getRGBImage(cmvr.api.CameraCommand.GetRGBImageCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getGetRGBImageMethod(), getCallOptions(), request);
    }

    /**
     */
    public cmvr.api.CameraCommand.GetDepthImageCommand.Feedback getDepthImage(cmvr.api.CameraCommand.GetDepthImageCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getGetDepthImageMethod(), getCallOptions(), request);
    }

    /**
     */
    public cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback getRGBDImages(cmvr.api.CameraCommand.GetRGBDImagesCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getGetRGBDImagesMethod(), getCallOptions(), request);
    }

    /**
     */
    public cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback startRecording(cmvr.api.CameraCommand.StartCameraRecordingCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getStartRecordingMethod(), getCallOptions(), request);
    }

    /**
     */
    public cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback stopRecording(cmvr.api.CameraCommand.StopCameraRecordingCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getStopRecordingMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class CameraServiceFutureStub extends io.grpc.stub.AbstractFutureStub<CameraServiceFutureStub> {
    private CameraServiceFutureStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected CameraServiceFutureStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new CameraServiceFutureStub(channel, callOptions);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.CameraCommand.GetCameraStateCommand.Feedback> getStatus(
        cmvr.api.CameraCommand.GetCameraStateCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getGetStatusMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.CameraCommand.StartCameraCommand.Feedback> startCamera(
        cmvr.api.CameraCommand.StartCameraCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getStartCameraMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.CameraCommand.StopCameraCommand.Feedback> stopCamera(
        cmvr.api.CameraCommand.StopCameraCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getStopCameraMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.CameraCommand.GetRGBImageCommand.Feedback> getRGBImage(
        cmvr.api.CameraCommand.GetRGBImageCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getGetRGBImageMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.CameraCommand.GetDepthImageCommand.Feedback> getDepthImage(
        cmvr.api.CameraCommand.GetDepthImageCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getGetDepthImageMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback> getRGBDImages(
        cmvr.api.CameraCommand.GetRGBDImagesCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getGetRGBDImagesMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback> startRecording(
        cmvr.api.CameraCommand.StartCameraRecordingCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getStartRecordingMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback> stopRecording(
        cmvr.api.CameraCommand.StopCameraRecordingCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getStopRecordingMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_GET_STATUS = 0;
  private static final int METHODID_START_CAMERA = 1;
  private static final int METHODID_STOP_CAMERA = 2;
  private static final int METHODID_GET_RGBIMAGE = 3;
  private static final int METHODID_GET_DEPTH_IMAGE = 4;
  private static final int METHODID_GET_RGBDIMAGES = 5;
  private static final int METHODID_START_RECORDING = 6;
  private static final int METHODID_STOP_RECORDING = 7;
  private static final int METHODID_GET_RGBIMAGE_STREAM = 8;
  private static final int METHODID_GET_DEPTH_IMAGE_STREAM = 9;
  private static final int METHODID_GET_RGBDIMAGES_STREAM = 10;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final CameraServiceImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(CameraServiceImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_GET_STATUS:
          serviceImpl.getStatus((cmvr.api.CameraCommand.GetCameraStateCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetCameraStateCommand.Feedback>) responseObserver);
          break;
        case METHODID_START_CAMERA:
          serviceImpl.startCamera((cmvr.api.CameraCommand.StartCameraCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StartCameraCommand.Feedback>) responseObserver);
          break;
        case METHODID_STOP_CAMERA:
          serviceImpl.stopCamera((cmvr.api.CameraCommand.StopCameraCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StopCameraCommand.Feedback>) responseObserver);
          break;
        case METHODID_GET_RGBIMAGE:
          serviceImpl.getRGBImage((cmvr.api.CameraCommand.GetRGBImageCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBImageCommand.Feedback>) responseObserver);
          break;
        case METHODID_GET_DEPTH_IMAGE:
          serviceImpl.getDepthImage((cmvr.api.CameraCommand.GetDepthImageCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetDepthImageCommand.Feedback>) responseObserver);
          break;
        case METHODID_GET_RGBDIMAGES:
          serviceImpl.getRGBDImages((cmvr.api.CameraCommand.GetRGBDImagesCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBDImagesCommand.Feedback>) responseObserver);
          break;
        case METHODID_START_RECORDING:
          serviceImpl.startRecording((cmvr.api.CameraCommand.StartCameraRecordingCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StartCameraRecordingCommand.Feedback>) responseObserver);
          break;
        case METHODID_STOP_RECORDING:
          serviceImpl.stopRecording((cmvr.api.CameraCommand.StopCameraRecordingCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.StopCameraRecordingCommand.Feedback>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_GET_RGBIMAGE_STREAM:
          return (io.grpc.stub.StreamObserver<Req>) serviceImpl.getRGBImageStream(
              (io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBImageStreamCommand.Feedback>) responseObserver);
        case METHODID_GET_DEPTH_IMAGE_STREAM:
          return (io.grpc.stub.StreamObserver<Req>) serviceImpl.getDepthImageStream(
              (io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetDepthImageStreamCommand.Feedback>) responseObserver);
        case METHODID_GET_RGBDIMAGES_STREAM:
          return (io.grpc.stub.StreamObserver<Req>) serviceImpl.getRGBDImagesStream(
              (io.grpc.stub.StreamObserver<cmvr.api.CameraCommand.GetRGBDImagesStreamCommand.Feedback>) responseObserver);
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class CameraServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    CameraServiceBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return cmvr.api.CameraServiceOuterClass.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("CameraService");
    }
  }

  private static final class CameraServiceFileDescriptorSupplier
      extends CameraServiceBaseDescriptorSupplier {
    CameraServiceFileDescriptorSupplier() {}
  }

  private static final class CameraServiceMethodDescriptorSupplier
      extends CameraServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    CameraServiceMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (CameraServiceGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new CameraServiceFileDescriptorSupplier())
              .addMethod(getGetStatusMethod())
              .addMethod(getStartCameraMethod())
              .addMethod(getStopCameraMethod())
              .addMethod(getGetRGBImageMethod())
              .addMethod(getGetDepthImageMethod())
              .addMethod(getGetRGBDImagesMethod())
              .addMethod(getStartRecordingMethod())
              .addMethod(getStopRecordingMethod())
              .addMethod(getGetRGBImageStreamMethod())
              .addMethod(getGetDepthImageStreamMethod())
              .addMethod(getGetRGBDImagesStreamMethod())
              .build();
        }
      }
    }
    return result;
  }
}
